<!-- http://erlangen-crm.org/current/P128_carries should be actually http://rs.mpiwg-berlin.mpg.de/Thing_from_Time, that is just a quick workaround for the current issue with date-range FRs in facets -->
<style>
  .facet-relations{
      min-width: 200px;
  }
</style>
<mp-event-proxy id='clipboard-update-on-save-set' on-event-source='save-set-result-action'
                proxy-event-type='Component.Refresh' proxy-targets='["clipboard-sidebar"]'
></mp-event-proxy>

<mp-event-proxy id='clipboard-update-on-save-search' on-event-source='save-search-result-action'
                proxy-event-type='Component.Refresh' proxy-targets='["clipboard-sidebar"]'
></mp-event-proxy>

<mp-event-proxy id='clipboard-update-on-persisted-component' on-event-source='persit-component-action'
                proxy-event-type='Component.Refresh' proxy-targets='["clipboard-sidebar"]'
></mp-event-proxy>

<semantic-search
  optimizer=blazegraph
  search-profile='{
    "categories": [
      {"iri": "<http://rs.mpiwg-berlin.mpg.de/Thing>", "label": "Thing", "thumbnail": "../images/fcs/things.svg"},
      {"iri": "<http://rs.mpiwg-berlin.mpg.de/Actor>", "label": "Actor", "thumbnail": "../images/fcs/actors.svg"},
      {"iri": "<http://rs.mpiwg-berlin.mpg.de/Place>", "label": "Place", "thumbnail": "../images/fcs/places.svg"},
      {"iri": "<http://rs.mpiwg-berlin.mpg.de/Time>", "label": "Time", "thumbnail": "../images/fcs/dates.svg"},
      {"iri": "<http://rs.mpiwg-berlin.mpg.de/Concept>", "label": "Concept", "thumbnail": "../images/fcs/concepts.svg"}
    ],
    "relations": [
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Thing_by_Actor>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Actor>",
        "label": "by"
      },
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Thing_from_Place>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Place>",
        "label": "from"
      },
      {
        "iri": "<http://erlangen-crm.org/current/P128_carries>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Time>",
        "label": "from"
      },
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Thing_has_type_Concept>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Concept>",
        "label": "has type"
      },
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Actor_is_owner_or_creator_of_Thing>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Actor>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "label": "is owner or creator of"
      },
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Place_is_origin_of_Thing>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Place>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "label": "is origin of"
      },
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Time_is_origin_of_Thing>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Time>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "label": "is origin of"
      },
      {
        "iri": "<http://rs.mpiwg-berlin.mpg.de/Concept_is_type_of_Thing>",
        "hasDomain": "<http://rs.mpiwg-berlin.mpg.de/Concept>",
        "hasRange": "<http://rs.mpiwg-berlin.mpg.de/Thing>",
        "label": "is type of"
      }
    ]
  }'
  categories='{
    "<http://rs.mpiwg-berlin.mpg.de/Time>": [{
      "kind": "date-range"
    }]
  }'
  relations='{
    "<http://rs.mpiwg-berlin.mpg.de/Thing_by_Actor>": [{
      "kind": "resource",
      "queryPattern": "
        {
          ?subject crm:P128_carries/frbroo:R24i_was_created_through/crm:P14_carried_out_by ?__value__ .
        } UNION {
          ?subject crm:P52_has_current_owner ?__value__ .
        } UNION {
          ?subject crm:P128_carries/crm:P165_incorporates/frbroo:R17i_was_created_by/crm:P14_carried_out_by ?__value__ .
        }
      "
    }],
    "<http://rs.mpiwg-berlin.mpg.de/Thing_from_Place>": [{
      "kind": "resource",
      "queryPattern": "
        ?subject crm:P128_carries/frbroo:R24i_was_created_through/crm:P7_took_place_at ?__value__ .
      "
    }],
    "<http://erlangen-crm.org/current/P128_carries>": [{
      "kind": "date-range",
      "queryPattern": "
        ?subject crm:P128_carries/frbroo:R24i_was_created_through/crm:P4_has_time-span/crm:P82_at_some_time_within ?time .
        FILTER(STRDT(?time, xsd:date) <= ?__dateEndValue__ && STRDT(?time, xsd:date) >= ?__dateBeginValue__) .
      "
    }],
    "<http://rs.mpiwg-berlin.mpg.de/Thing_has_type_Concept>": [{
      "kind": "resource",
      "queryPattern": "
        {
          ?subject frbroo:R7_is_example_of/crm:P2_has_type ?__value__ .
        } UNION {
          ?subject crm:P128_carries/crm:P165_incorporates/crm:P72_has_language ?__value__
        }
      "
    }],
    "<http://rs.mpiwg-berlin.mpg.de/Actor_is_owner_or_creator_of_Thing>": [{
      "kind": "resource",
      "queryPattern": "
        {
          ?__value__ crm:P128_carries/frbroo:R24i_was_created_through/crm:P14_carried_out_by ?subject.
        } UNION {
          ?__value__ crm:P52_has_current_owner ?subject .
        } UNION {
          ?__value__ crm:P128_carries/crm:P165_incorporates/frbroo:R17i_was_created_by/crm:P14_carried_out_by ?subject .

        }
      "
    }],
    "<http://rs.mpiwg-berlin.mpg.de/Place_is_origin_of_Thing>": [{
      "kind": "resource",
      "queryPattern": "
        ?__value__ crm:P128_carries/frbroo:R24i_was_created_through/crm:P7_took_place_at ?subject .
      "
    }],
    "<http://rs.mpiwg-berlin.mpg.de/Time_is_origin_of_Thing>": [{
      "kind": "resource",
      "queryPattern": "
        ?__value__ crm:P128_carries/frbroo:R24i_was_created_through/crm:P4_has_time-span ?time .
      "
    }],
    "<http://rs.mpiwg-berlin.mpg.de/Concept_is_type_of_Thing>": [{
      "kind": "resource",
      "queryPattern": "
        {
          ?__value__ frbroo:R7_is_example_of/crm:P2_has_type ?subject .
        } UNION {
          ?__value__ crm:P128_carries/crm:P165_incorporates/crm:P72_has_language ?subject
        }
      "
    }]
  }'
>
  [[> @partial-block ]]

  <div data-flex-layout="row stretch-stretch">
    <div data-flex-self="size-1of3" style="flex: 0 0 0;">
      <semantic-search-facet
        open-by-default=true
        value-relations='{
          "<http://erlangen-crm.org/current/P128_carries>": {
            "kind": "date-range",
            "valuesQuery": "
               SELECT ?dateBeginValue ?dateEndValue WHERE {
                 ?subject crm:P128_carries/frbroo:R24i_was_created_through/crm:P4_has_time-span/crm:P82_at_some_time_within ?time .
                 FILTER(STRLEN(?time) = 4) .
                 BIND(STRDT(CONCAT(?time, \"-01-01\"), xsd:date) as ?dateBeginValue) .
                 BIND(STRDT(CONCAT(?time, \"-01-01\"), xsd:date) as ?dateEndValue) .
            } ORDER BY ?dateBeginValue"
           }
        }'
        default-value-queries='{
          "resource": "
            SELECT ?value ?label (COUNT(DISTINCT $subject) AS ?count) WHERE {
              FILTER(?__facetRelationPattern__)
              {
                ?value (rdfs:label|crm:P3_has_note|crm:P82_at_some_time_within) ?label.
              } UNION {
                ?value (crm:P1_is_identified_by/crm:P3_has_note) ?label.
              }
            } GROUP BY ?value ?label ORDER BY ?label
          "
        }'
      ></semantic-search-facet>
    </div>

    <semantic-search-result-holder>
      <div data-flex-self="md-full">
        <bs-tabs unmount-on-exit=true id='search-results' animation=false class='tabs-right'>
          <bs-tab event-key='1' title='Grid'>
            <semantic-search-result>
              <semantic-table
                query='
                  SELECT ?subject ?label ?image WHERE {
                    OPTIONAL {
                      ?subject crm:P138i_has_representation ?image .
                    }
                    ?subject crm:P1_is_identified_by/crm:P3_has_note ?label .
                  } ORDER BY DESC(?image) ?label
                ' id="grid-result" tuple-template='{{> itemTemplate}}'
                options='{"showFilter": false}'
              >
                <template id='itemTemplate'>
                  {{> Partial:itemCard iri=subject}}
                </template>
              </semantic-table>
            </semantic-search-result>
          </bs-tab>
          <bs-tab event-key='2' title='Table'>
            <semantic-search-result>
              <semantic-table query="SELECT ?subject WHERE {}" id="table-result"></semantic-table>
            </semantic-search-result>
          </bs-tab>
          <bs-tab event-key="3" title="Chart">
            <semantic-search-result-context ranges='["http://rs.mpiwg-berlin.mpg.de/Concept", "http://rs.mpiwg-berlin.mpg.de/Place", "http://rs.mpiwg-berlin.mpg.de/Actor"]'>
              <semantic-search-result>
                <mp-component-toolbar>
                  <mp-component-toolbar-actions>
                    <semantic-chart-type-selector default="bar" types='["line", "bar", "radar", "pie", "donut"]' style='margin-right: 10px;'></semantic-chart-type-selector>
                    <mp-component-toolbar-action-download></mp-component-toolbar-action-download>
                    <mp-component-toolbar-action-save id='persit-component-action' add-to-default-set=true></mp-component-toolbar-action-save>
                  </mp-component-toolbar-actions>
                  <mp-component-toolbar-component>
                    <semantic-chart
                      id='search-result-chart'
                      query='
                        SELECT ?object (COUNT(DISTINCT ?subject) as ?count) WHERE {
                          OPTIONAL { FILTER(?__contextRelationPattern__) }
                          BIND(IF(BOUND(?__value__), ?__value__, "Unknown") as ?object)
                        } GROUP BY ?object ORDER BY DESC(?count)
                      '
                      sets='[{
                        "category": "object",
                        "value": "count"
                      }]'>
                    </semantic-chart>
                  </mp-component-toolbar-component>
                </mp-component-toolbar>
              </semantic-search-result>
            </semantic-search-result-context>
          </bs-tab>
        </bs-tabs>
        <hr>
        <div class="pull-right" style="display: flex;">
          <semantic-search-result>
            <mp-sparql-download id='csv-result' query="SELECT ?subject WHERE { }"
                                header="text/csv"
                                filename="csv-result.csv"
                                >
              <button class="btn btn-default" style="margin-right:10px">Download CSV</button>
            </mp-sparql-download>
          </semantic-search-result>
          <semantic-search-action-use-result-in-extended-search>
            <button class="btn btn-default" style="margin-right:10px">Use in Search</button>
          </semantic-search-action-use-result-in-extended-search>
          <semantic-search-action-save-set-result id='save-set-result-action'>
            <button class="btn btn-default" style="margin-right:10px">Save As Set</button>
          </semantic-search-action-save-set-result>
          <semantic-search-action-save-search-result id='save-search-result-action' add-to-default-set=true>
            <button class="btn btn-default" style="margin-right:10px">Save As Search</button>
          </semantic-search-action-save-search-result>
        </div>
      </div>
    </semantic-search-result-holder>
  </div>
</semantic-search>
